<?php
/**
 * WoWRoster.net WoWRoster
 *
 * Displays the guild information text
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: index.php $
 * @link       http://www.wowroster.net
 * @package    MadeBy
*/

if( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

$roster->output['title'] = $roster->locale->act['MadeBy_title_addon'];

include_once( $addon['inc_dir'].'recipe.lib.php');

$qry_prof = "SELECT `config_name` FROM `".$roster->db->table('addon_config')."`"
          . " WHERE `config_type` = 'made_pref'"
          . " AND `config_value` = '1'"
          . " AND `addon_id` = '".$addon['addon_id']."'"
          . " ORDER BY `config_name`";

$result_prof = $roster->db->query($qry_prof) or die_quietly($roster->db->error(),'Database Error',basename(__FILE__),__LINE__,$qry_prof);

$valid_skills = array();
while ($row = $roster->db->fetch($result_prof))
{
    $valid_skills[$row['config_name']] = $roster->locale->act[$row['config_name']];
}
asort($valid_skills);

$qualitylist = array(
	'all'=>'%',
	'common'=>'ffffff',
	'uncommon'=>'1eff00',
	'rare'=>'0070dd',
	'epic'=>'a335ee'
);

  $profBar = '';
  $choiceForm = '<form action="'.current_url('').'" method="post" name="myform">'."\n";
  //profesion filter
  $choiceForm .='<table border="0"><tr><th class="copy">'.$roster->locale->act['professionfilter'].'</th><td class="copy"><select name="proffilter">'."\n";

  $profBar .= '|&nbsp;';
  $choiceForm .= '<option value="none">'.$roster->locale->act['MB_Select_Professions'].'</option>'."\n";
  foreach($valid_skills as $key=>$skill)
  {
    $profBar .= '<a href="' .current_url('&amp;proffilter='.$key).'">'.$skill.'</a> | ';
    if (isset($_REQUEST["proffilter"]) && $_REQUEST["proffilter"]==$key)
    {
    	$choiceForm .= '<option value="'.$key.'" selected="selected">'.$skill.'</option>'."\n";
    } else {
    	$choiceForm .= '<option value="'.$key.'">'.$skill.'</option>'."\n";
    }
  }
  $profBar .= '<br />'."\n";
  $choiceForm .= '</select></td>'."\n";
  //quality filter
  $choiceForm .='<th class="copy">'.$roster->locale->act['qualityfilter'].'</th><td class="copy"><select name="qualfilter">'."\n";
  foreach($qualitylist as $qlt=>$color)
  {
  	if (isset($_REQUEST["qualfilter"]) && $_REQUEST["qualfilter"]==$color)
  	{
  		$choiceForm .= '<option value="'.$color.'" selected="selected">'.$roster->locale->act[$qlt].'</option>'."\n";
    } else {
    	$choiceForm .= '<option value="'.$color.'">'.$roster->locale->act[$qlt].'</option>'."\n";
    }
  }
  $choiceForm .= '</select></td>'."\n";
  //search box
  $choiceForm .='<th>'.$roster->locale->act['search'].'</th><td><input type="text" name="filterbox"';
  if (isset($_REQUEST['filterbox']))
  {
    $choiceForm .= ' value="'.$_REQUEST['filterbox'].'"';
  }
  $choiceForm .= ' /></td><td><input type="submit" value="'.$roster->locale->act['applybutton'].'" /></td></tr></table></form><br />'."\n";

  $content .= '<a id="top_menu"></a>'.$choiceForm;

  if ($addon['config']['display_prof_bar'])
  {
    $content .= $profBar.'<hr width="80%" />'."\n";
  }

  global $sortby_d;

  $sort_d = '0';

if (isset($_REQUEST["proffilter"]))
{
$roster->output['title'] = $roster->locale->act['MadeBy_title_addon'].' - '.$roster->locale->act[$_REQUEST["proffilter"]];
	$current_options = '&amp;proffilter='.$_REQUEST["proffilter"];
	if ( isset($_REQUEST['filterbox']))
	{
		$current_options .= '&amp;filterbox='.$_REQUEST['filterbox'].'&amp;qualfilter='.$_REQUEST["qualfilter"];
	}
	$all_options = $current_options;
	if ( isset($_REQUEST['sort']))
	{
		$all_options .= '&amp;sort='.$_REQUEST["sort"];
	}	
  if ( isset($_REQUEST['reverse']) &&  $_REQUEST['reverse'] == '1')
  {
    $sort_d = '0';
    $sortby_d=1;
    $all_options .= '&amp;reverse=1';
  }
  else
  {
    $sort_d = '1';
    $sortby_d = 0;
  }

  if ( $_REQUEST["proffilter"] != 'none')
  {
    $usedlang = array();
    switch ($addon['config']['display_multilanguage'])
    {
      case 1: // Auto **** change guild_id on realm scope! ****
        $usedlang[] = $roster->config['locale'];
        $qry_lang = "SELECT DISTINCT `clientLocale` FROM `".$roster->db->table('players')."`"
                  . " WHERE `guild_id` = '".$roster->data['guild_id']."' ORDER BY `clientLocale` ASC";

        $result_lang = $roster->db->query($qry_lang) or die_quietly($roster->db->error(),'Database Error',basename(__FILE__),__LINE__,$qry_lang);

        while ($row = $roster->db->fetch($result_lang))
        {
          $usedlang[] = $row['clientLocale'];
        }
        $usedlang = array_unique($usedlang);
        sort($usedlang);
      break;
      case 2: // All
        foreach( $roster->multilanguages as $lang )
        {
          $usedlang[] = $lang;
        }
      break;
      case 0: // Only current
      default:
        $usedlang[] = $roster->config['locale'];
    }
    
    $crafters = crafters_get_all($_REQUEST["proffilter"], $usedlang, $roster->data['guild_id']); // **** change guild_id on realm scope! ****

    extract( recipe_get_all(  $_REQUEST["proffilter"], $usedlang,
    (isset($_REQUEST["qualfilter"]) ? $_REQUEST["qualfilter"] : '%'),
    (isset($_REQUEST["filterbox"]) ? $_REQUEST["filterbox"] : ''),
    (isset($_REQUEST["sort"]) ? $_REQUEST["sort"] : $addon['config']['default_sort_by']),
    $roster->data['guild_id'])); // **** change guild_id on realm scope! ****
  }

// START HERE.
  if( count($recipes) !=0 )
  {
    $rc = 0;
    $recipe_type = '';
    $first_table = true;
// add wrapping of table and center?
    $content .=  '<table align="center" border="0"><tr><td align="center" valign="middle"> - ';

    foreach($recipe_types as $type=>$typegb)
    {
      $content .=  '<a href="'.current_url($all_options.'#'.$typegb).'">'.$type.'</a> - ';
      $rc++;
      if ($rc == '8')
      {
      	$content .='<br /> - ';
      }
    }
    $rc = 0;
    
    if (!isset($_REQUEST["filterbox"]) && !isset($_REQUEST["qualfilter"]))
  	{
  		$percent = round((count($recipes)*100)/$maxrecipes,1);
  		if ($percent < '100' && $addon['config']['display_missing'])
  		{
  			$content .= '<a href="'.current_url($all_options.'#missing').'">#'.$roster->locale->act['missing'].'</a> - ';
  		}
  	}
    
    $content .=  "</td></tr></table><br /><br />\n";

    foreach ($recipes as $recipe)
    {
      if ($recipe_type != $recipe->data['type'])
      {
        $recipe_type = $recipe->data['type'];

        if(!$first_table)
        {
          $content .=  '</table>'.border('syellow','end').'<br />'."\n";
        }
        $first_table = false;
        $content .= border('syellow','start', '<a id="'.$recipe_types[$recipe_type].'" href="'.current_url($all_options.'#top_menu').'">'.$recipe_type.'</a>');
        $content .= '<table class="bodyline" cellspacing="0">';
        $content .= '<tr>'."\n";

        if ($addon['config']['display_recipe_icon'])
        {
          $content .=  '<th class="membersHeader">&nbsp;'.$roster->locale->act['item'].'&nbsp;</th>'."\n";
        }
        if ($addon['config']['display_recipe_name'])
        {
          $content .=  '<th class="membersHeader"><a href="'.current_url($current_options.'&amp;sort=type').'">'.$roster->locale->act['name'].'</a></th>'."\n";
        }
        if ($addon['config']['display_recipe_skill'])
        {
          $content .=  '<th class="membersHeader"><a href="'.current_url($current_options.'&amp;sort=skill&amp;reverse='.$sort_d).'">'.$roster->locale->act['skill'].'</a></th>'."\n";
        }
        if ($addon['config']['display_recipe_level'])
        {
          $content .=  '<th class="membersHeader"><a href="'.current_url($current_options.'&amp;sort=level&amp;reverse='.$sort_d).'">'.$roster->locale->act['level'].'</a></th>'."\n";
        }
        if ($addon['config']['display_recipe_tooltip'])
        {
          $content .=  '<th width="220" class="membersHeader">&nbsp;'.$roster->locale->act['itemdescription'].'&nbsp;</th>'."\n";
        }
        if ($addon['config']['display_recipe_type'])
        {
          $content .=  '<th class="membersHeader">&nbsp;'.$roster->locale->act['type'].'&nbsp;</th>'."\n";
        }
        if ($addon['config']['display_recipe_reagents'])
        {
          $content .=  '<th class="membersHeader">&nbsp;'.$roster->locale->act['reagents'].'&nbsp;</th>'."\n";
        }
        if ($addon['config']['display_recipe_makers'])
        {
          $content .=  '<th class="membersHeader">&nbsp;'.$roster->locale->act['whocanmakeit'].'&nbsp;</th>'."\n";
        }
        $content .=  '</tr>';
      }
      $users = '';
      $break_counter = 0;

      foreach($recipe->data['by'] as $user_id=>$difficulty)
      {
        if (!array_key_exists($user_id, $crafters))
        {
// a member with recipes without skill to use them?
          $query_user = "SELECT `name`"
                 . " FROM `".$roster->db->table('players')."`"
                 . " WHERE `member_id` = '".$user_id."'"
                 . " LIMIT 1";
          $result_user = $roster->db->fetch($roster->db->query($query_user)) or die_quietly($roster->db->error(),'Database Error',basename(__FILE__),__LINE__,$query_user);
          $crafters[$user_id] = new crafter (array ( 'name' => $result_user['name'],
                                                                'skill' => '0:375',
                                                                 'spec' => $roster->locale->act[$_REQUEST["proffilter"]]));
        }
        if ($break_counter == $addon['config']['display_recipe_makers_count'])
        {
          $users .= '<br />';
          $break_counter = 0;
        }
        elseif( $users != '' )
        {
          $users .= ', ';
        }
        $users .= '<a href="'.makelink('char-info-recipes&amp;a=c:'.$user_id).'" ';
        $tooltip_skill = 'onmouseover="return overlib(memberoverlib_' . $user_id . ');" onmouseout="return nd();"';
        switch ($crafters[$user_id]->data['skill'])
        {
            case ROSTER_MAXSKILLLEVEL.":".ROSTER_MAXSKILLLEVEL:
            case "385:385": // be racial
                 $users .= 'class="difficulty_1';
            break;
            case '0:'.ROSTER_MAXSKILLLEVEL:
                 $users .= 'class="difficulty_5';
                 $tooltip_skill = 'onmouseover="return overlib(memberoverlib_0);" onmouseout="return nd();"';
            break;
            default:
                 $users .= 'class="difficulty_'.$difficulty;
        }
        $users .= '"  '.$tooltip_skill.'>'.$crafters[$user_id]->data['name'].'</a>';
        $break_counter++;
      }

// Increment counter so rows are colored alternately
      ++$rc;

      $table_cell_start = '<td class="membersRow'.(($rc%2)+1).'" align="center" valign="middle">';

    $quality = '';  
    if( $recipe->data['quality']  == '' )
    {
      $recipe->data['quality']  = 'ffffff';
    }
    if( strlen($recipe->data['quality'])  > 6 )
    {
      $quality = substr( $recipe->data['quality'],  2, 6 );
    } else {
      $quality = $recipe->data['quality'];
    }

      $content .=  '<tr>'."\n";
      if ($addon['config']['display_recipe_icon'])
      {
        $content .=  $table_cell_start.'<div class="equip">';
        $content .=  $recipe->out($recipe->data['name']);
        $content .=  '</div></td>';
      }
      if ($addon['config']['display_recipe_name'])
      {
          $content .=  $table_cell_start.'&nbsp;<span style="color:#'.$quality.';font-size:12px;font-weight:bold;" '.makeOverlib($roster->locale->act['tooltip_source'].': '.$recipe->data['source'],'','',2,'',',RIGHT,WRAP').'>'.$recipe->data['name'].'</span>&nbsp;</td>'."\n";
      }
      if ($addon['config']['display_recipe_skill'])
      {
        $content .=  $table_cell_start.'&nbsp;'.$recipe->data['skill'].'&nbsp;</td>'."\n";
      }
      if ($addon['config']['display_recipe_level'])
      {
        $content .=  $table_cell_start.'&nbsp;'.$recipe->data['level'].'&nbsp;</td>'."\n";
      }
      if ($addon['config']['display_recipe_tooltip'])
      {
        $tooltip = '';
        if (array_key_exists($roster->config['locale'], $recipe->data))
          {
              $tooltip = colorTooltip(stripslashes($recipe->data[$roster->config['locale']]['tooltip']),$quality);
          }
        elseif (array_key_exists('enUS', $recipe->data))
          {
              $tooltip = colorTooltip(stripslashes($recipe->data['enUS']['tooltip']),$quality,'enUS');
          }
        $content .=  $table_cell_start.'<table style="width:240;white-space:normal;"><tr><td>'.stripslashes($tooltip).'</td></tr></table></td>'."\n";
      }
      if ($addon['config']['display_recipe_type'])
      {
        $content .=  $table_cell_start.'&nbsp;'.$recipe->data['type'].'&nbsp;</td>'."\n";
      }
      if ($addon['config']['display_recipe_reagents'])
      {
        $reagents = '';
        if (array_key_exists($roster->config['locale'], $recipe->data))
          {
              $reagents =$recipe->data[$roster->config['locale']]['reagents'];
          }
        elseif (array_key_exists('enUS', $recipe->data))
          {
              $reagents =$recipe->data['enUS']['reagents'];
          }
        $content .=  $table_cell_start.'&nbsp;'.str_replace('<br>','&nbsp;<br />&nbsp;',$reagents).'</td>'."\n";
      }
      if ($addon['config']['display_recipe_makers'])
      {
        $content .=  $table_cell_start.'&nbsp;'.$users.'&nbsp;</td>'."\n";
      }
      $content .=  '</tr>';
    }
    $content .=  '</table>'.border('syellow','end');
    if (isset($percent))
    {
    $content .= '<br /><center>'.count($recipes).'/'.$maxrecipes.' ('.$percent.'%) of <b>Recipes</b> from '.count($crafters).' <b>Crafters</b></center><br />'."\n";
      if ($percent < '100' && $addon['config']['display_missing'])
      {
        $content .= border('syellow','start', '<a id="missing" href="'.current_url($all_options.'#top_menu').'">#'.$roster->locale->act['missing'].'</a>');
        $content .= '<table class="bodyline" cellspacing="0">'."\n";
        $content .= '<tr>'."\n";
        $content .=  '<th class="membersHeader">&nbsp;'.$roster->locale->act['item'].'&nbsp;</th>'."\n";
        $content .=  '<th class="membersHeader"><a href="'.current_url($current_options.'&amp;sort=type').'">'.$roster->locale->act['name'].'</a></th>'."\n";
        $content .=  '<th class="membersHeader"><a href="'.current_url($current_options.'&amp;sort=skill&amp;reverse='.$sort_d).'">'.$roster->locale->act['skill'].'</a></th>'."\n";
        $content .=  '<th class="membersHeader"><a href="'.current_url($current_options.'&amp;sort=level&amp;reverse='.$sort_d).'">'.$roster->locale->act['level'].'</a></th>'."\n";
        $content .=  '<th class="membersHeader">&nbsp;'.$roster->locale->act['type'].'&nbsp;</th>'."\n";
        $content .=  '</tr>';

        foreach($RecipeList as $recipe_name=>$val)
        {
        		++$rc;
        		$table_cell_start = '<td class="membersRow'.(($rc%2)+1).'" align="center" valign="middle">';
            $extra = explode("#", $val);
            // 0:Skill 1:Source 2:Icon 3:Quality 4:Type 5:Required Level
								// Item links
                $num_of_tips = (count($tooltips)+1);
                $linktip = '';
                foreach( $roster->locale->act['data_links'] as $key => $ilink )
                {
                  $linktip .= '<a href="'.$ilink.rawurlencode(utf8_decode($recipe_name)).'" target="_blank">'.$key.'</a><br />';
                }
                setTooltip($num_of_tips,$linktip);
                setTooltip('itemlink',$roster->locale->act['data_search']);
                $linktip = ' onclick="return overlib(overlib_'.$num_of_tips.',CAPTION,overlib_itemlink,STICKY,NOCLOSE,WRAP,OFFSETX,5,OFFSETY,5);"';

            $path = $roster->config['interface_url']. 'Interface'.DIR_SEP.'Icons'.DIR_SEP.$extra[2].'.'.$roster->config['img_suffix'];
            $content .=  '<tr>'."\n";
            $content .=  $table_cell_start.'<div class="equip">';
            $content .= '<div class="item" '.$linktip.'><img src="'.$path.'" class="icon" alt="" /></div>';
            $content .=  '</div></td>'."\n";

            $content .=  $table_cell_start.'&nbsp;<span style="color:#'.$extra[3].';font-size:12px;font-weight:bold;" '.makeOverlib($roster->locale->act['tooltip_source'].': '.$extra[1],'','',2,'',',RIGHT,WRAP').'>'.$recipe_name.'</span>&nbsp;</td>'."\n";
            $content .=  $table_cell_start.'&nbsp;'.ltrim($extra[0],0).'&nbsp;</td>'."\n";
            $content .=  $table_cell_start.'&nbsp;'.ltrim($extra[5],0).'&nbsp;</td>'."\n";
            $content .=  $table_cell_start.'&nbsp;'.$extra[4].'&nbsp;</td>'."\n";
            $content .=  '</tr>'."\n";
        }
        $content .=  '</table>'.border('syellow','end');
      }
    }
  }
  else
  {
      $content .=  $roster->locale->act['dnotpopulatelist'];
  }
// END HERE.

}

$content .= '<br /><br /><br />'.MADEBY_VERSION."\n";

function current_url($optional='')
  {
  	global $roster,$addon;
  		$current_url = makelink($roster->pages[0].'-'.$addon['basename'].'&amp;a=g:'.$roster->data['guild_id'].$optional);
  	return $current_url;
  }
